require '_h2ph_pre.ph';

unless(defined(&_SYS_MODEL_H)) {
    eval 'sub _SYS_MODEL_H () {1;}' unless defined(&_SYS_MODEL_H);
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL)) {
	require 'sys/debug.ph';
    }
    require 'sys/isa_defs.ph';
    if(defined( &_KERNEL) || defined( &_KMEMUSER)) {
	eval 'sub DATAMODEL_MASK () {0x0ff00000;}' unless defined(&DATAMODEL_MASK);
	eval 'sub DATAMODEL_ILP32 () {0x00100000;}' unless defined(&DATAMODEL_ILP32);
	eval 'sub DATAMODEL_LP64 () {0x00200000;}' unless defined(&DATAMODEL_LP64);
	eval 'sub DATAMODEL_NONE () {0;}' unless defined(&DATAMODEL_NONE);
	if(defined( &_LP64)) {
	    eval 'sub DATAMODEL_NATIVE () { &DATAMODEL_LP64;}' unless defined(&DATAMODEL_NATIVE);
	}
 elsif(defined( &_ILP32)) {
	    eval 'sub DATAMODEL_NATIVE () { &DATAMODEL_ILP32;}' unless defined(&DATAMODEL_NATIVE);
	} else {
	    die("No DATAMODEL_NATIVE specified");
	}
    }
    unless(defined(&_ASM)) {
    }
    if(defined( &_KERNEL)  && !defined( &_ASM)) {
	if(defined( &_LP64)) {
	    eval 'sub STRUCT_HANDLE {
	        local($struct_type, $handle) = @_;
    		eval q(\'struct __\'$handle &_type {  &union { \'struct struct_type\'32* &m32; \'struct struct_type\' * &m64; }  &ptr;  &model_t  &model; } $handle = {  &NULL,  &DATAMODEL_ILP32 });
	    }' unless defined(&STRUCT_HANDLE);
	    eval 'sub STRUCT_DECL {
	        local($struct_type, $handle) = @_;
    		eval q(\'struct struct_type\'  &__$handle &_buf;  &STRUCT_HANDLE($struct_type, $handle));
	    }' unless defined(&STRUCT_DECL);
	    eval 'sub STRUCT_SET_HANDLE {
	        local($handle, $umodel, $addr) = @_;
    		eval q(. &model = ($umodel) &  &DATAMODEL_MASK;  &ASSERT((($umodel) &  &DATAMODEL_MASK) !=  &DATAMODEL_NONE); (($handle). ($ptr->{m64})) = ($addr));
	    }' unless defined(&STRUCT_SET_HANDLE);
	    eval 'sub STRUCT_INIT {
	        local($handle, $umodel) = @_;
    		eval q( &STRUCT_SET_HANDLE($handle, $umodel, & &__$handle &_buf));
	    }' unless defined(&STRUCT_INIT);
	    eval 'sub STRUCT_SIZE {
	        local($handle) = @_;
    		eval q((($handle). &model ==  &DATAMODEL_ILP32 ? $sizeof{($handle). ($ptr->{m32})} : $sizeof{($handle). ($ptr->{m64})}));
	    }' unless defined(&STRUCT_SIZE);
	    eval 'sub STRUCT_FADDR {
	        local($handle, $field) = @_;
    		eval q((($handle). &model ==  &DATAMODEL_ILP32 ? ( &void *)($handle). ($ptr->{m32}->{field}) : ($handle). ($ptr->{m64}->{field})));
	    }' unless defined(&STRUCT_FADDR);
	    eval 'sub STRUCT_FGET {
	        local($handle, $field) = @_;
    		eval q(((($handle). &model ==  &DATAMODEL_ILP32) ? ($handle). ($ptr->{m32}->{field}) : ($handle). ($ptr->{m64}->{field})));
	    }' unless defined(&STRUCT_FGET);
	    eval 'sub STRUCT_FGETP {
	        local($handle, $field) = @_;
    		eval q((. &model ==  &DATAMODEL_ILP32 ? ($handle). ($ptr->{m32}->{field}) : ($handle). ($ptr->{m64}->{field})));
	    }' unless defined(&STRUCT_FGETP);
	    eval 'sub STRUCT_FSET {
	        local($handle, $field, $val) = @_;
    		eval q((($handle). &model ==  &DATAMODEL_ILP32 ? (($handle). ($ptr->{m32}->{field}) = ($val)) : (($handle). ($ptr->{m64}->{field}) = ($val))));
	    }' unless defined(&STRUCT_FSET);
	    eval 'sub STRUCT_FSETP {
	        local($handle, $field, $val) = @_;
    		eval q((. &model ==  &DATAMODEL_ILP32 ? (. ($ptr->{m32}->{field}) = ) : (($handle). ($ptr->{m64}->{field}) = ($val))));
	    }' unless defined(&STRUCT_FSETP);
	    eval 'sub STRUCT_BUF {
	        local($handle) = @_;
    		eval q((($handle). ($ptr->{m64})));
	    }' unless defined(&STRUCT_BUF);
	    eval 'sub SIZEOF_PTR {
	        local($umodel) = @_;
    		eval q(((($umodel) &  &DATAMODEL_MASK) ==  &DATAMODEL_ILP32 ? $sizeof{ &caddr32_t} : $sizeof{\'caddr_t\'}));
	    }' unless defined(&SIZEOF_PTR);
	    eval 'sub SIZEOF_STRUCT {
	        local($struct_type, $umodel) = @_;
    		eval q(((($umodel) &  &DATAMODEL_MASK) ==  &DATAMODEL_ILP32 ? $sizeof{\'struct struct_type\'32} : $sizeof{\'struct struct_type\'}));
	    }' unless defined(&SIZEOF_STRUCT);
	} else {
	    eval 'sub STRUCT_HANDLE {
	        local($struct_type, $handle) = @_;
    		eval q(\'struct __\'$handle &_32 { \'struct struct_type\' * &ptr; }; \'struct __\'$handle &_32 $handle = {  &NULL });
	    }' unless defined(&STRUCT_HANDLE);
	    eval 'sub STRUCT_DECL {
	        local($struct_type, $handle) = @_;
    		eval q(\'struct struct_type\'  &__$handle &_buf;  &STRUCT_HANDLE($struct_type, $handle));
	    }' unless defined(&STRUCT_DECL);
	    if(defined(&lint)) {
		eval 'sub STRUCT_SET_HANDLE {
		    local($handle, $umodel, $addr) = @_;
    		    eval q( ($umodel); ($handle). &ptr = ($addr));
		}' unless defined(&STRUCT_SET_HANDLE);
	    } else {
		eval 'sub STRUCT_SET_HANDLE {
		    local($handle, $umodel, $addr) = @_;
    		    eval q(($handle). &ptr = ($addr));
		}' unless defined(&STRUCT_SET_HANDLE);
	    }
	    eval 'sub STRUCT_INIT {
	        local($handle, $umodel) = @_;
    		eval q( &STRUCT_SET_HANDLE($handle, $umodel, & &__$handle &_buf));
	    }' unless defined(&STRUCT_INIT);
	    eval 'sub STRUCT_SIZE {
	        local($handle) = @_;
    		eval q(($sizeof{($handle). &ptr}));
	    }' unless defined(&STRUCT_SIZE);
	    eval 'sub STRUCT_FADDR {
	        local($handle, $field) = @_;
    		eval q((($handle). ($ptr->{field})));
	    }' unless defined(&STRUCT_FADDR);
	    eval 'sub STRUCT_FGET {
	        local($handle, $field) = @_;
    		eval q((($handle). ($ptr->{field})));
	    }' unless defined(&STRUCT_FGET);
	    eval 'sub STRUCT_FGETP () { &STRUCT_FGET;}' unless defined(&STRUCT_FGETP);
	    eval 'sub STRUCT_FSET {
	        local($handle, $field, $val) = @_;
    		eval q((($handle). ($ptr->{field}) = ($val)));
	    }' unless defined(&STRUCT_FSET);
	    eval 'sub STRUCT_FSETP () { &STRUCT_FSET;}' unless defined(&STRUCT_FSETP);
	    eval 'sub STRUCT_BUF {
	        local($handle) = @_;
    		eval q((($handle). &ptr));
	    }' unless defined(&STRUCT_BUF);
	    eval 'sub SIZEOF_PTR {
	        local($umodel) = @_;
    		eval q($sizeof{\'caddr_t\'});
	    }' unless defined(&SIZEOF_PTR);
	    eval 'sub SIZEOF_STRUCT {
	        local($struct_type, $umodel) = @_;
    		eval q($sizeof{\'struct struct_type\'});
	    }' unless defined(&SIZEOF_STRUCT);
	}
	if(defined( &_LP64) || defined( &lint) || defined( &__lint)) {
	} else {
	    eval 'sub lwp_getdatamodel {
	        local($t) = @_;
    		eval q( &DATAMODEL_ILP32);
	    }' unless defined(&lwp_getdatamodel);
	    eval 'sub get_udatamodel () {
	        eval q( &DATAMODEL_ILP32);
	    }' unless defined(&get_udatamodel);
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
